Package com.tibco.patterns.learn.rlink

## Class ConfFeature

- java.lang.Object
- - com.tibco.patterns.learn.rlink.ConfFeature

- All Implemented Interfaces:
    `Confidence`
  Direct Known Subclasses:
    `ConfQFeature`

      public class ConfFeature
      extends java.lang.Object
      implements Confidence

  Feature based confidence measure. Immutable class.

  This measure is available for model versions RFV6 and higher (ibi Patterns 5.4). It takes into account the the combination of feature scores seen.

  This measure provides the best overall measure of confidence in the prediction. However it is also quite expensive to compute, so may not be appropriate for use with production query loads.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static double` | `USE_DFT_BLUR_REGION_WIDTH` | Special value to indicate that the server must use default blur region width.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ConfFeature()` | Create an instance with default values.
    `ConfFeature​(int minDiff, double blurWindow)` | Create an instance with specific parameter values.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `getBlurWindow()` |
    `int` | `getConfType()` | Return the confidence type.
    `double` | `getDblArg​(int idx)` | Return a double parameter.
    `int` | `getIntArg​(int idx)` | Return an integer parameter.
    `int` | `getMinDiff()` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### USE_DFT_BLUR_REGION_WIDTH

          public static final double USE_DFT_BLUR_REGION_WIDTH

      Special value to indicate that the server must use default blur region width.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ConfFeature

          public ConfFeature()

      Create an instance with default values.

    - #### ConfFeature

          public ConfFeature​(int minDiff,
                             double blurWindow)

      Create an instance with specific parameter values.
      Parameters:
        `minDiff` - The number of unambiguous training examples needed to reach full confidence. This is the number of unambiguous examples that trained the same combination of feature scores: ABS(True examples - False examples). Only the examples seen in the first training iteration are counted.
        `blurWindow` - When considering the region trained by a particular set of scores a certain amount of leeway, or blurring of the region can be introduced. This accounts for the way model training functions. This option sets the width of the blur region. A value of 0.0 uses no blur, a value of 1.0 blurs the entire area. The default value is 0.18.
      Throws:
        `java.lang.IllegalArgumentException` - if a parameter is not in legal range.

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getConfType

          public int getConfType()

      Return the confidence type.
      Specified by:
        `getConfType` in interface `Confidence`
      Returns:
        the confidence type for the Feature-based measure.

    - #### getMinDiff

          public int getMinDiff()

      Returns:
        number of training examples that trained a particular feature score combination needed for full confidence. Always positive.

    - #### getBlurWindow

          public double getBlurWindow()

      Returns:
        the width of the blur region (negative if default is used).

    - #### getIntArg

          public int getIntArg​(int idx)

      Return an integer parameter. The first parameter is the minimum difference count.
      Specified by:
        `getIntArg` in interface `Confidence`
      Parameters:
        `idx` - the integer parameter index, zero based.
      Returns:
        The minimum difference count for index 0, -1 otherwise.

    - #### getDblArg

          public double getDblArg​(int idx)

      Return a double parameter. The blur window size.
      Specified by:
        `getDblArg` in interface `Confidence`
      Parameters:
        `idx` - the double parameter index, zero based.
      Returns:
        index 0: the blur window size. -1.0 for other indexes.